/**
 * EasyBeans
 * Copyright (C) 2006 Bull S.A.S.
 * Contact: easybeans@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: PostConstruct00.java 830 2006-07-11 09:51:35Z studzine $
 * --------------------------------------------------------------------------
 */
package org.objectweb.easybeans.tests.common.interceptors.lifecycle.postconstruct;

import javax.annotation.PostConstruct;
import javax.interceptor.InvocationContext;

import org.objectweb.easybeans.log.JLog;
import org.objectweb.easybeans.log.JLogFactory;
import org.objectweb.easybeans.tests.common.ejbs.base.ItfCheckPostConstruct;


/**
 * Interceptor for lifecycle callback event.
 * @author Eduardo Studzinski Estima de Castro
 * @author Gisele Pinheiro Souza
 */
public class PostConstruct00 {

    /**
     * Log helper.
     */
    private JLog logger = JLogFactory.getLog(PostConstruct00.class);

    /**
     * PostConstruct lifecyle callback interceptor.
     * @param ic contains attributes of invocation
     */
    @PostConstruct
    public void interceptor(final InvocationContext ic){
        logger.debug("PostConstruct was invoked.");
        try {
            if (ic.getTarget() instanceof ItfCheckPostConstruct && ic.getMethod() == null){
                ((ItfCheckPostConstruct) ic.getTarget()).setStatus(true);
            }
            ic.proceed();
        } catch (Exception e) {
            logger.debug("Exception: {0}", e.toString());
            throw new IllegalStateException("Exception in " + PostConstruct00.class.getName());
        }
    }

}
